#import <Foundation/Foundation.h>


@interface Base : NSObject
{
   unsigned int  hash;
}

@end


@implementation Base

- (unsigned int) _hash
{
   NSAssert( NO, @"Do not call me");
}


- (id) init
{
   [super init];
   hash = [self _hash];
   return( self);
}


- (unsigned int) hash
{
   return( hash);
}

@end



@interface Foo : Base
{
}

@end


@implementation Foo


- (unsigned int) _hash
{
   static unsigned int  counter;

   ++counter;
   return( ((counter >> 24) & 0xFF)       |
           ((counter >> 16) & 0xFF) <<  8 |
           ((counter >> 8)  & 0xFF) << 16 |
           ((counter)       & 0xFF) << 24);
}


@end


@interface Bar : Base
{
}

@end


@implementation Bar

- (unsigned int) _hash
{
   static unsigned int  counter;

   ++counter;
   return( counter);
}

@end



#define OBJECTS  5000


int main (int argc, const char *argv[])
{
   NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
   unsigned int  i;
   NSHashTable   *table;

   table = NSCreateHashTable( NSNonRetainedObjectHashCallBacks , OBJECTS);
   NSLog( @"Start Foo");
   for( i = 0; i < OBJECTS; i++)
      NSHashInsertKnownAbsent( table, [[Foo alloc] init]);
   NSLog( @"End Foo");


   table = NSCreateHashTable( NSNonRetainedObjectHashCallBacks, OBJECTS);
   NSLog( @"Start Bar");
   for( i = 0; i < OBJECTS; i++)
      NSHashInsertKnownAbsent( table, [[Bar alloc] init]);
   NSLog( @"End Bar");

   [pool release];
   exit(0);       // insure the process exit status is 0
   return 0;      // ...and make main fit the ANSI spec.
}

